#include "field.h"
#include <fstream>



Field::Field(fstream& F,int n,int m)
	{
		N = n;
		M = m;
		table = new double *[N];

		for (int i=0;i<N;i++)
		{
			table[i] = new double[M];
		}

		for(int i=0;i<N;i++)
		{
			for(int j=0;j<M;j++)
			{
				F >> table[i][j];
				if (table[i][j] < 1 || table[i][j] > 100000)
				    throw exception ("Error! Does not comply with the constrictions");
			}
		}
	}

Field::Field(const Field & F2)
	{
		N = F2.N;
		M = F2.M;
		table = new double *[N];

		for (int i=0;i<M;i++)
		{
			table[i] = new double[M];
		}

		for(int i=0;i<N;i++)
		{
			for(int j=0;j<M;j++)
			{
				table[i][j] = F2.table[i][j];
			}
		}
	}

Field::~Field()
	{
		for( int i = 0 ; i < N ; i++ )
		delete [] table[i] ;
		delete [] table ;
	}

bool Field::landing(Animal& landing_Animal)
{	
	for (int x=0;x<(get_n()-landing_Animal.get_r());x++)
	{
		for (int y=0;y<(get_m()-landing_Animal.get_c());y++)
		{
			bool flag = true;
			for (int p=0;p<landing_Animal.get_r();p++)
			{
				for (int q=0;q<landing_Animal.get_c();q++)
				{	
					if(landing_Animal.get_table_member(p,q) == 1)
					{
						if(landing_Animal.get_safety() > get_table_member(x+p,y+q))
						{
							flag = false;
						}
					}
				}
			}
			if(flag==true)
			{
				landing_Animal.succeed();
				landing_Animal.set_coords(x,y);
				landing_effect(landing_Animal);
				return true;
			}
		}
	}
	return false;
}

void Field::landing_effect(Animal& landing_Animal)
{
	int index1=0;
	int index2=0;
	for (int x=landing_Animal.get_x();x<(landing_Animal.get_x() + landing_Animal.get_r());x++)
	{
		for (int y=landing_Animal.get_y();y<(landing_Animal.get_y() + landing_Animal.get_c());y++)
		{
			if(landing_Animal.get_table_member(index1,index2) == 1)
			{
				double temp=0;
				temp = get_table_member(x,y) / landing_Animal.get_effect();
				set_table_member(x,y,temp);
			}	
				index2 += 1;
		}
		index1 += 1;
	}
}